"""Camera class for MEEG"""

import pygame

class Camera(pygame.sprite.Sprite):
    """a class that translates rects to get the final image for a frame"""
    def __init__(self, level, game):
        self.level = level
        self.game = game
        self.image = self.game.screen
        self.rect = self.image.get_rect()
        pygame.sprite.Sprite.__init__(self)
        
    def rbgnd(self):
        self.image.blit(self.level.bgnd, (0,0))
        
    def rlevel(self):
        seen = pygame.sprite.spritecollide(self, self.level.data, False)
        for tile in seen:
            translated = tile.rect.move(-self.rect.left, 0)
            self.image.blit(tile.image, translated)
        
    def rentities(self):
        #player
        prect = self.game.player.rect.move(-self.rect.left, 0)
        self.image.blit(self.game.player.image, prect)
    
    def draw(self):
        self.rect.centerx = (self.game.player.rect.centerx)
        if self.rect.left < 0:
            self.rect.left = 0
        if self.rect.right > len(self.level.array)*32:
            self.rect.right = len(self.level.array)*32
        self.rbgnd()
        self.rlevel()
        self.rentities()
