"""Basic moving living thing in-game"""

import entity, vector

import pygame

class Character(entity.Entity):
    """contains all game mechanics methods except for physics, handled by ragdoll"""
    def __init__(self, level, image, pos):
        entity.Entity.__init__(self, level, image, pos)
        
    def update(self):
        entity.Entity.update(self)
        
    def collidecheck(self, newpos):
        top = self.level.get_at(newpos.centerx, newpos.top)
        bottom = self.level.get_at(newpos.centerx, newpos.bottom)
        left1 = self.level.get_at(newpos.left, newpos.centery-(self.rect.height/4))
        left2 = self.level.get_at(newpos.left, newpos.centery+(self.rect.height/4))
        right1 = self.level.get_at(newpos.right, newpos.centery-(self.rect.height/4))
        right2 = self.level.get_at(newpos.right, newpos.centery+(self.rect.height/4))
        
        if top and top.solid == "true":
            newpos.top = top.rect.bottom
        if bottom and bottom.solid == "true":
            newpos.bottom = bottom.rect.top
        if right1 and right1.solid == "true":
            newpos.right = right1.rect.left
        if right2 and right2.solid == "true":
            newpos.right = right2.rect.left
        if left1 and left1.solid == "true":
            newpos.left = left1.rect.right
        if left2 and left2.solid == "true":
            newpos.left = left2.rect.right
        
        return newpos
