"""Class for player character, with the special abilities and all"""

import character, vector

import pygame

class Player(character.Character):
    """Adds in mutate and pickup features"""
    def __init__(self, controller, level):
        self.controller = controller
        character.Character.__init__(self, level, "res/chars/player/test.png", level.find_tag("spawnp"))
        self.facing = "right"
        self.speed = 8
        self.jump = -32 #remember y axis flip
        self.jumping = False
        self.add_vector("d", (0, 0))
        self.add_vector("a", (0, 0))
        self.add_vector("space", (0, 0))
        
        
    def update(self):
        if self.controller.keys["r"]:
            self.rect.topleft = self.level.find_tag("spawnp")
        if self.controller.keys["d"]:
            if self.facing != "right":
                self.image = pygame.transform.flip(self.image, True, False)
                self.facing = "right"
            self.vectors["d"] = vector.Vec2d(self.speed, 0)
            
        if not self.controller.keys["d"]:
            self.vectors["d"] = vector.Vec2d(0, 0)
            
        if self.controller.keys["a"]:
            if self.facing != "left":
                self.image = pygame.transform.flip(self.image, True, False)
                self.facing = "left"
            self.vectors["a"] = vector.Vec2d(-self.speed, 0)
            
        if not self.controller.keys["a"]:
            self.vectors["a"] = vector.Vec2d(0, 0)
            
        below = self.level.get_at(self.rect.centerx, self.rect.inflate(2, 2).bottom)
        if below and below.solid == "true":
            self.vectors["space"] = vector.Vec2d(0, 0)
            if self.controller.keys["space"]:
                self.vectors["space"] = vector.Vec2d(0, self.jump)
            
        character.Character.update(self)
